/*=========================================================*/
/*
* Parallel Recursive Spectral Bisection -
* Based on the sequential version provided by Horst Simon
* -ravi
*/
/*=========================================================*/

#include <stdio.h>
#include "parti.h"

/*=========================================================*/
opk(sched, xadj, adj, diag, a, b, n, n_off_proc)
SCHED *sched;
int *xadj, *adj;
double *diag, *a, *b;
int n, n_off_proc;
{
   int i, j, k;

   for(i=0; i<n; i++) {
     b[i] = b[i]+diag[i]*a[i];
   }
   for(i=0; i<n_off_proc; i++) {
     b[n+i] = 0.0;
   }

   for(i=0; i<n; i++) {
     for(j=xadj[i]; j<xadj[i+1]; j++) {
       k = adj[j];
       b[k] = b[k]+a[i];
     }
   }

   PARTI_scatter(sched, &b[n], b, sizeof(double), PARTI_add);
}
/*=========================================================*/


ortho(neqns, r, teqns)
double *r;
int teqns, neqns;
{

   int i;
   double srn, sum, dwork;

     sum = 0.0;
     for(i=0; i<neqns; i++) {
       sum = sum + r[i];
     }

     srn = 1.0/(double)teqns;
     PARTI_gdsum(&sum, 1, &dwork);
/*
     printf("---> SRN %f  SUM %1.6e\n", srn , sum);
*/
     sum = sum * srn;

     for(i=0; i<neqns; i++) {
       r[i] = r[i] - sum;
     }
} 
/*=========================================================*/
      

opk1(sched, xadj, adj, diag, a, b, n, n_off_proc)
SCHED *sched;
int *xadj, *adj;
double *diag, *a, *b;
int n, n_off_proc;
{
   int i, j, k;

   for(i=0; i<n; i++) {
     b[i] = b[i]+diag[i]*a[i];
   }
   for(i=0; i<n_off_proc; i++) {
     b[n+i] = 0.0;
   }

   if(PARTI_mynode == 0)
   printf("in opk  %d\n", PARTI_mynode); PARTI_gsync();

   for(i=0; i<n; i++) {
     for(j=xadj[i]; j<xadj[i+1]; j++) {
       k = adj[j];
       b[k] = b[k]+a[i];
     }
   }
   printf("in opk  sched->ndata[%d] %d\n", PARTI_mynode, sched->ndata); PARTI_gsync();

   PARTI_scatter(sched, &b[n], b, sizeof(double), PARTI_add);
/*
   for(i=0; i<20; i++) printf("OPK: R[%d] %f\n", i, b[i]);
*/
}

/*=========================================================*/

